#!/usr/bin/perl -w

use strict;
use CGI qw(:standard);

# function declaracion:
sub write2file;
sub printResult;

my $cgi = new CGI; # create new CGI object

# Content-type for HTML answer to client:
print $cgi->header(-type => 'text/html');

# get file data (name and data itself)
our $file = $cgi->param("UploadFile");

# create file name (we use the original filename, but could be anything you like)
#my $fname = 'file_'.$$.'_'.$ENV{REMOTE_ADDR}.'_'.time;
our $fname = $file;

# depending on the file type we receive prepare different text blocks to be displayed in the HTML- page
# prepare the strings:

my $MessageUserResourceZip = <<MSG_USER_RESOURCE_ZIP;
 <h1><p><img src="ok.png"> user_resource upload OK</p>
 </h1><p>&nbsp;</p>
 <p>The user_resource folder has been uploaded correctly.</p>
MSG_USER_RESOURCE_ZIP

my $MessageMacroXml = <<MSG_MACRO_XML;
 <h1><p><img src="ok.png"> macroxx.xml upload OK</p>
 </h1><p>&nbsp;</p>
 <p>The macroxx.xml file has been uploaded correctly.</p>
MSG_MACRO_XML

my $MessagePagesXml = <<MSG_PAGES_XML;
 <h1><p><img src="ok.png"> pages.xml upload OK</p>
 </h1><p>&nbsp;</p>
 <p>The pages.xml file has been uploaded correctly.</p>
MSG_PAGES_XML

my $MessageImagePng = <<MSG_IMAGE_PNG;
 <h1><p><img src="ok.png"> image.png upload OK</p>
 </h1><p>&nbsp;</p>
 <p>The image.png file has been uploaded correctly.</p>
MSG_IMAGE_PNG

my $MessageBackgroundBmp = <<MSG_BMP;
 <h1><p><img src="ok.png"> Background Bitmap upload OK</p>
 </h1><p>&nbsp;</p>
 <p>The background bitmap file has been uploaded correctly.<br>The changed bitmap will be shown if "Individual Design" has been selected.</p>
MSG_BMP

my $MessageScreenSaver = <<MSG_SCRN;
 <h1><p><img src="ok.png"> Screen saver image upload OK</p>
 </h1><p>&nbsp;</p>
 <p>The screen saver image file has been uploaded correctly.<br>
    The changed image will be shown the next time the screen saver is invoked.</p>
MSG_SCRN

my $MessageConfigData = <<MSG_CNFG;
 <h1><p><img src="ok.png"> Config Data upload OK.</p>
 </h1><p>&nbsp;</p>
 <p>The file <b>ConfigData.bin</b> has been stored.<br>The display will now reboot for the changes to take effect.</p>
MSG_CNFG

my $MessageConfigDataXml = <<MSG_CNFG;
 <h1><p><img src="ok.png"> XML Config Data upload OK.</p>
 </h1><p>&nbsp;</p>
 <p>The file <b>ConfigData.xml</b> has been stored.<br>The display will now reboot for the changes to take effect.</p>
MSG_CNFG

my $MessageApp = <<MSG_CNFG;
 <h1><p><img src="ok.png"> Application upload OK.</p>
 </h1><p>&nbsp;</p>
 <p>The file <b>xtouchPANEL_NT</b> has been stored.<br>The display will now reboot for the changes to take effect.</p>
MSG_CNFG

my $MessageTestBookData = <<MSG_TEST;
 <h1><p><img src="ok.png"> Test Book Data upload OK.</p>
 </h1><p>&nbsp;</p>
 <p>The file <b>TestBook.bin</b> has been stored.<br>The display will now reboot for the changes to take effect.</p>
MSG_TEST

my $MessageUpdateData = <<MSG_UPDATE;
 <h1><p><img src="ok.png"> Software Update upload OK.</p>
 </h1><p>&nbsp;</p>
 <p>The file <b>$file</b> has been stored.<br>The display will now reboot for the changes to take effect.</p>
MSG_UPDATE

my $MessageUploadFail = <<MSG_FAIL;
 <h1><p><img src="fail.png"> File upload FAILED.</p>
 </h1><p>&nbsp;</p>
 <p>The file <b>$file</b> could not be uploaded correctly.<br>The reason may be either an incorrect filename or an unsupported format. Please retry.</p>
MSG_FAIL

my $ReturnLinkActive = <<MSG_RETURN;
  <tr>   
    <td align="left" height="40" width="200" valign="middle"></td>
    <td align="left" height="40" valign="middle" width="700">
    <p><img src="arrow.gif" alt=" " align="baseline"> <a href="update.htm">return to upload page</a></p>
    <p><img src="arrow.gif" alt=" " align="baseline"> <a href="index.htm">return to main page</a></p>
    <p>&nbsp;</p>
    </td>
  </tr>
MSG_RETURN

my $ReturnLinkReboot = <<MSG_RETURN_REBOOT;
  <tr>   
    <td align="left" height="40" width="200" valign="middle"></td>
    <td align="left" height="40" valign="middle" width="700">
	<p>After reboot you may want to:<p>
    <p><img src="arrow.gif" alt=" " align="baseline"> <a href="update.htm">return to upload page</a></p>
    <p><img src="arrow.gif" alt=" " align="baseline"> <a href="index.htm">return to main page</a></p>
    <p>&nbsp;</p>
    </td>
  </tr>
MSG_RETURN_REBOOT

my $MessageStr = $MessageUploadFail;
my $ReturnLink = $ReturnLinkActive;

# handle our file types:
#
#1) screensaver.png
#        - needs to be placed in ../resources/screensaver.png
#        - no reboot necessary
#		 - V1.04: added .PNG (for Windows)
if (($fname eq "screensaver.png") || ($fname eq "screensaver.PNG"))
{
	$fname = "../resource/screensaver.png";
	write2file;
	$MessageStr = $MessageScreenSaver;
	printResult;
	return;
} 
#
#2) background.png
#        - needs to be placed in ../resources/background.png
#        - no reboot necessary
#		 - V1.04: added .PNG (for Windows)
if (($fname eq "background.png") || ($fname eq "background.PNG"))
{
	$fname = "../resource/background.png";
	write2file;
	$MessageStr = $MessageBackgroundBmp;
#	$ReturnLink = "";	# if we need a system reboot do not show the "return to" links
#	$ReturnLink = $ReturnLinkReboot;
	printResult;
#	system('/etc/init.d/reboot');
#	exit 0;
	return;
} 
#
#3a) ConfigData.bin
#        - needs to be placed in ../ConfigData.bin
#        - reboot necessary
#
if ($fname eq "ConfigData.bin") 
{
	$fname = "../$file";
	write2file;
	$MessageStr = $MessageConfigData;
#	$ReturnLink = "";	# if we need a system reboot do not show the "return to" links
	$ReturnLink = $ReturnLinkReboot;
	printResult;
	system('/sbin/reboot -d -f -i');
	exit 0;
}
#
#3b) ConfigData.xml
#        - needs to be placed in ../ConfigData.bin
#        - reboot necessary
#
if ($fname eq "ConfigData.xml") 
{
  $fname = "../$file";
  write2file;
  $MessageStr = $MessageConfigDataXml;
# $ReturnLink = ""; # if we need a system reboot do not show the "return to" links
  $ReturnLink = $ReturnLinkReboot;
  printResult;
  system('/sbin/reboot -d -f -i');
  exit 0;
}
#
#5) Program update (zipped AutoRun file, but named: xetouch_Vxxx.zip)
#       - xxx= version number, should be ignored when comparing the file name
#        - place "somewhere", delete after update
#        - unzip and do the system update
#        - reboot
#
if ($fname =~ m/DALIDisplay_V\d+\.zip/)
{
	$MessageStr = $MessageUpdateData;
#	$ReturnLink = "";	# if we need a system reboot do not show the "return to" links
	$ReturnLink = $ReturnLinkReboot;
	mkdir('/temp');
	$fname = "/temp/$file";
	
	printResult;
	system('/usr/loader/loader &');
	system('/bin/sleep 1');
	write2file;	
	exit 0;
}
#
#6) xtouchPANEL_NT  (intended for development only)
#        - needs to be placed in ../
#        - reboot necessary
#
if ($fname eq "xtouchPANEL_NT") 
{
	$fname = "../$file";
	write2file;
	$MessageStr = $MessageApp;
#	$ReturnLink = "";	# if we need a system reboot do not show the "return to" links
	$ReturnLink = $ReturnLinkReboot;
	printResult;
	system('/sbin/reboot -d -f -i');
	exit 0;
}
#
#7) pages.xml
#        - needs to be placed in ../resources/pages.xml
#        - no reboot necessary
if ($fname eq "pages.xml")
{
	$fname = "../user_resource/pages.xml";
  if (0 ne system("ls /home/user_resource"))
  {
    system(" mkdir /home/user_resource");
  }
	write2file;
	$MessageStr = $MessagePagesXml;
	printResult;
	return;
} 

#
#8) imagename.png
#        - needs to be placed in ../resources/*.png
#        - no reboot necessary
if($fname =~ m/.png/i)
{
  $fname = '../user_resource/'.$fname;
  if (0 ne system("ls /home/user_resource"))
  {
    system(" mkdir /home/user_resource");
  }
	write2file;
	$MessageStr = $MessageImagePng;
	printResult;
	return;
} 

#
#9) macroxx.xml
#        - needs to be placed in ../resources/*.png
#        - no reboot necessary
if(($fname =~ m/macro/i) && ($fname =~ m/.xml/i))
{
  $fname = '../user_resource/'.$fname;
  if (0 ne system("ls /home/user_resource"))
  {
    system(" mkdir /home/user_resource");
  }
	write2file;
	$MessageStr = $MessageMacroXml;
	printResult;
	return;
}

#
#10) user_resource.zip
#        - needs to be placed in /home/user_source.zip
#        - no reboot necessary
if ($fname eq "user_resource.zip")
{
  $fname = '/home/'.$fname;
  write2file;
  system("rm -rf /home/user_resource");
  system(" mkdir /home/user_resource");
  system("unzip -q -o /home/user_resource.zip -d /home/user_resource/");
  system("rm /home/user_resource.zip");
  if (0 eq system("ls /home/user_resource/user_resource"))
  {
    #print "there is folder inside";
    system("cp -a /home/user_resource/user_resource/. /home/user_resource/");
    system("rm -rf /home/user_resource/user_resource");
  }
  else
  {
    #print "no folder";
  }
	$MessageStr = $MessageUserResourceZip;
	printResult;
  exit 0;
}

#
#10a) user_resource.tar
#        - needs to be placed in /home/user_source.tar
#        - no reboot necessary
if ($fname eq "user_resource.tar")
{
  $fname = '/home/'.$fname;
  write2file;
  system("rm -rf /home/user_resource");
  system(" mkdir /home/user_resource");
  #system("tar -xzvf /home/user_resource.tar -C /home/user_resource");
  system("tar -xzf /home/user_resource.tar -C /home/user_resource");
  system("rm /home/user_resource.tar");
  if (0 eq system("ls /home/user_resource/user_resource"))
  {
    #print "there is folder inside";
    system("cp -a /home/user_resource/user_resource/. /home/user_resource/");
    system("rm -rf /home/user_resource/user_resource");
  }
  else
  {
    #print "no folder";
  }
	$MessageStr = $MessageUserResourceZip;
	printResult;
  exit 0;
}
# this is for test what happens if folder "user_resource" is missing
if ($fname eq "remove_user_resource")
{
  system("rm -rf /home/user_resource");
  exit 0;
}
#
# else print the "upload fail" message:
printResult;


#--------------------------------------------------------------
#--------------------------------------------------------------
#--------------------------------------------------------------


#--------------------------------------------------------------
#
sub write2file
{
	open DAT, '>' .$fname or die 'Error processing file: ',$!;

	# since we do not know if we get a bin or text file, always use bin:
	binmode $file;
	binmode DAT;

	# write the file:
	my $data;
	while(read $file,$data,1024) {
	  print DAT $data;
	}

	close DAT;
}

#--------------------------------------------------------------
#
sub printResult
{
# compose the HTML page for the answer to the client:
print <<"HTML";
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>File Upload</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<meta http-equiv="pragma" content="no-cache">
<meta http-equiv="expires" content="0">
<meta name="robots" content="noindex">
<style type="text/css">
text {
    font-family: Verdana, Arial, Sans serif;
    font-size: 12px;
 	font-weight: bold;
 	}
a {
    color: #0099CC;
    font-family: Verdana;
    font-size: 10px;
 	font-weight: normal;
	color: #000000;
	margin-top: 8px;
	margin-bottom: 12px;
    text-decoration: none;
}
a:hover {
    text-decoration: underline;
}

body, textarea, td {
    color: #000000;
    font-family: Verdana;
    font-size: 11px;
    font-weight: normal;
    text-decoration: none;
}

h1 {
    font-family: Verdana, Arial, Sans serif;
    font-size: 11px;
 	font-weight: bold;
	margin-top: 0px;
	margin-bottom: 12px;

}

h3 {
    font-family: Verdana, Arial, Sans serif;
    font-size: 12px;
 	font-weight: bold;
	color: #000000;
	margin-top: 8px;
	margin-bottom: 12px;

}
</style>
</head>

<body bgcolor="#FFFFFF" text="#000000" leftmargin="0" topmargin="10" marginwidth="0"
marginheight="0">

<table width="902" border="0" align="center" cellspacing="0" cellpadding="0" style="border: solid 1px #000000;">
  <tr>
    <td colspan="2" align="center" valign="middle" width="900"> <img src="Header.jpg" border="0"></td>
  </tr>
  <tr>
    <td colspan="2" align="center" height="50" valign="middle" width="900">
    <h1>File Upload</h1>
    </td>
  </tr>
  <tr>
    <td align="left" height="230" width="200" valign="middle"></td>
    <td align="left" height="230" valign="middle" width="700">
    <p>&nbsp;</p>
    $MessageStr 
    <p>&nbsp;</p>
    </td>
  </tr>
  $ReturnLink
</table>
</body>
</html>
HTML
}







